﻿using EJGrid.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.JavaScript.Models;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Linq.Expressions;
using System.Web;
using System.Web.Mvc;
using System.Web.UI.WebControls;
using System.Xml;
using Syncfusion.Linq;

namespace EJGrid.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.dataSource = new NorthwindDataContext().Orders.Select(ds => ds.EmployeeID).Distinct().ToList();
            return View();
        }
        public ActionResult DataSource(DataManager dm)
        {
            IEnumerable DataSource = OrderRepository.GetAllRecords().ToList();
            DataResult result = new DataResult();
            DataOperations opt = new DataOperations();
            if (dm.Where != null)
            {
                DataSource = opt.PerformWhereFilter(DataSource, dm.Where, "");
                if(dm.Take == 0)
                return Json(DataSource, JsonRequestBehavior.AllowGet);
            }

            var count = DataSource.AsQueryable().Count();
            if (dm.Skip > 0)
                DataSource = opt.PerformSkip(DataSource, dm.Skip);
            if (dm.Take > 0)
                DataSource = opt.PerformTake(DataSource, dm.Take);
            result.result = DataSource;
            result.count = count;
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Update(List<EditableOrder> changed, List<EditableOrder> added, List<EditableOrder> deleted)
        {
            if(changed != null)
            OrderRepository.Update(changed);
            if (deleted != null)
                OrderRepository.Delete(deleted);
            if (added != null)
                OrderRepository.Add(added);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public IEnumerable PerformCustomWhereFilter(IEnumerable dataSource, List<WhereFilter> whereFilter)
        {
            Type type = dataSource.GetElementType();

            foreach (var filter in whereFilter)
            {
                if (filter.IsComplex)
                    dataSource = PerformCustomWhereFilter(dataSource, filter.predicates);
                else
                {
                    var paramExpression = dataSource.GetElementType().Parameter();
                    Expression predicate = null;
                    var a = filter.Operator;
                    a = FindFilterType(a.ToString());
                    Syncfusion.Linq.FilterType filterType = (Syncfusion.Linq.FilterType)Enum.Parse(typeof(Syncfusion.Linq.FilterType), a.ToString(), true);
                    Type t = type.GetProperty(filter.Field).PropertyType;
                    Type underlyingType = Nullable.GetUnderlyingType(t);

                    if (underlyingType != null)
                    {
                        t = underlyingType;
                    }

                    var value = Convert.ChangeType(filter.value, t);
                    predicate = dataSource.AsQueryable().Predicate(paramExpression, filter.Field, value, filterType, FilterBehavior.StringTyped, !filter.IgnoreCase, type);
                    dataSource = dataSource.AsQueryable().Where(paramExpression, predicate);

                }
            }
            return dataSource;
        }
        public string FindFilterType(string value)
        {
            string type = "Equals";
            switch (value)
            {
                case "startswith": type = "StartsWith";
                    break;
                case "endswith": type = "EndsWith";
                    break;
                case "notequal": type = "NotEquals";
                    break;
                case "contains": type = "Contains";
                    break;
                case "lessthan": type = "LessThan";
                    break;
                case "greaterthan": type = "GreaterThan";
                    break;
                case "lessthanorequal": type = "LessThanOrEqual";
                    break;
                case "greaterthanorequal": type = "GreaterThanOrEqual";
                    break;
            }
            return type;
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}